# API REST PHP Sample prototype with Slim + PDO in Docker

## Description

Basic API REST with a sample "Color" entity and all the basic REST methods already 
implemented. Look at `app/src/Controller` folder to get a general idea.

The project contains a `docker-compose` environment ready to run the service, but
you can use it also in a conventional hosted environment adjusting the corresponding
database parameters at `app/config.php`.

The `docker-compose` environment runs three containers: the webserver on port 80, a
MySQL database (DB), and a PHPMyAdmin (PMA) container on port 8080.

The sample application runs the following routes:

    GET http://localhost/hello/flx    Shows the name from the URL ("flx" in this case)
    GET http://localhost/color        Lists all the colors
    GET http://localhost/color/42     Shows the color by its id (42 in this case)
    POST http://localhost/color       Adds a new color
    PATCH http://localhost/color/42   Modifies an existing color by its id
    DELETE http://localhost/color/42  Completely deletes an existing color by its id

In the POST and PATCH methods, the data can be supplied as a `x-www-form-urlencoded` map
or with a JSON structure (ensure the `Content-Type` header is `application/json`).

The API will respond with 200, 400, or 404 errors in the status code value, and the
requested data if the call was executed correctly.

The Color API calls will return the color objects affected by the call, except for the
delete call that will simply return 200 or 404 as status code.

To access the PMA container, just go to `http://localhost:8080` and enter the database
credentials.

Look at the `docker.env` file to know or change the default DB settings if needed.

## Launching and stopping the docker container stack

To start all the containers, just "cd" to the main folder and run:

    docker-compose up -d

To stop and remove all the containers, just run:

    docker-compose down

## Build the vendor folder

To optimize the size of the git, no vendor libraries are included. To install the 
composer dependencies, just run:

    bin/composer.sh update

## Access MySQL database by cmd

To run SQL commands in the database, run:

    bin/mysql.sh

## Import the sample data

There is a `initial_data.sql` file that contains sample data for the Color model.

Import this data manually on SQL command-line or using the PMA access.

## File structure

This is the current folder strategy for this project:

    api_rest                    Main folder
      +- app                    Application folder
      |   +- html               HTML static content
      |   +- logs               Logs generated by monolog
      |   +- src                Source files for this app
      |   +- vendor             Libraries from composer
      |   +- composer.json      Composer required libraries
      |   +- composer.lock      Composer lock file with installed libs
      +- bin                    Some helpful scripts for Docker
      |   +- composer.sh        Use this for composer operations
      |   \- mysql.sh           Runs MySQL client on the DB container
      +- dbdata                 Docker volume data for the database
      +- .gitignore             Main .gitignore of the project
      +- docker-compose.yml     Docker stack definition
      +- docker.env             Environment variables
      +- initial-data.sql       SQL commands to deploy the initial data to the DB
      \- README.md              This file
